public class SingletonDemo {
	
	// Singleton object reference
	static SingletonDemo @ _instance;
	static int _instanceAccessedProperly; // needed to make sure you don't create instances before calling instance() once
	
	// Instance vars
	int i;
	float f;
	string s;
	
	// "Private constructor"
	// This is not really a constructor at all, just stops you from creating instances of this class
	if (_instance != null || !_instanceAccessedProperly) {
		<<< "[ERROR] Cannot create instances of SingletonDemo, use SingletonDemo.instance() instead" >>>;
		me.exit();
	}
	
	// Static method to retrieve the singleton instance
	fun static SingletonDemo instance() {
		if (_instance == null) {
			true => _instanceAccessedProperly;
			new SingletonDemo @=> _instance;
		}
		return _instance;
	}
	
	// Static method to modify the singleton instance, without the need to retrieve it first
	fun static void init(int i, float f, string s) {
		i => instance().i;
		f => instance().f;
		s => instance().s;
	}
	
}
